;       
;                                                                     *
;**********************************************************************
;    Filename:	    Voltmeter.asm                                           *
;    Date:             27.03.08                                               *
;    File Version:  01                                                  *
;                                                                     *
;    Author:  		A. Kusnetsov                                                        *
;    Company:                                                         *
;**********************************************************************
;    Notes:                                                           *
;     PIC16F88   8MHz                                                                *
;**********************************************************************

	list      p=16f88           ; list directive to define processor
	#include <p16F88.inc>        ; processor specific variable definitions

	errorlevel  -302              ; suppress message 302 from list file

	__CONFIG    _CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_ON & _MCLR_OFF & _PWRTE_ON & _WDT_OFF & _INTRC_IO
	__CONFIG    _CONFIG2, _IESO_OFF & _FCMEN_OFF


;***** VARIABLE DEFINITIONS
	 cblock	0x20	;      20h.
	 index		;    (  TMR0)
	 count		;   b2_bcd 	
	 temp		;   
	 flags		;  
	 flags1          ;   
	 
	 H_byte		;  AD   
	 L_byte  		;  AD 
	 H_sum		;   AD 
	 L_sum		;   AD 
	
	 tr1			;bcd-  
	 tr2			;bcd-    

	 ciph3		;7- 3 
	 ciph2		;7- 2 
	 ciph1		;7- 1 
	 
	 fcounter		;   10 
	 count_sampl	;  
	 
	 mins_10		; 
        hours_10	; 
        count_tmr       ;  
        count_btn      ;    
       
        count_min       ;   
        count_sec       ;   
	 count_hour		;  
	
	cnt1			;  3 
	cnt2
	cnt3
	endc	        ;   
	
w_temp        EQU     	0x71        ; variable used for context saving 
status_temp   EQU     	0x72        ; variable used for context saving
pclath_temp   EQU     0x73	  ; variable used for context saving

#define	seg_kod		PORTB		; 7 .  
#define	SA3		PORTA,3	; -  "-"
#define	knopka		PORTA,5	; -  
#define	AD_start	ADCON0, 2	; A/D 
#define	off_seg		clrf	PORTB	;  
#define	big_cykle	flags,0		;  

#define	mode	flags1,0		;   
#define	ch_SA3	flags1,1		;   

;************ ***************
BANK0    MACRO  
		 BCF      STATUS,RP1  
		 BCF      STATUS,RP0  
		 ENDM
		;
BANK1    MACRO  
		 BCF      STATUS,RP1  
		 BSF      STATUS,RP0  
		 ENDM
		;
BANK2    MACRO  
		 BSF      STATUS,RP1  
		 BCF      STATUS,RP0  
		 ENDM
		;
BANK3    MACRO  
		 BSF      STATUS,RP1  
		 BSF      STATUS,RP0  
		 ENDM
		;
VOLT1    MACRO  				;  AN0/RA0,    
		 BCF      ADCON0, 3  
		 BCF      ADCON0, 4  
		 ENDM

AMPER  MACRO  				;  AN1/RA1, 
		 BCF      ADCON0, 4  
		 BSF      ADCON0, 3  
		 ENDM	

VOLT2    MACRO  				;  AN2/RA2,   
		 BCF      ADCON0, 3  
		 BSF      ADCON0, 4  
		 ENDM
		 
R1		 MACRO  				;  1
		 BSF      PORTA,7  
		 BSF	PORTA,6
		 BCF      PORTA,4   
		 ENDM
		 
R2		 MACRO  				;  2
		 BSF      PORTA,4 
		 BSF      PORTA,7
		 BCF       PORTA,6
		 ENDM
		 
R3		 MACRO  				;  3
		 BSF      PORTA,6  
		 BSF      PORTA,4
		 BCF      PORTA,7  
		 ENDM	

INIT_AD MACRO
		call		delay_10		;   
		clrf		H_sum				; 
		clrf		L_sum				; 
		clrf		count_sampl		 
		ENDM
;**********************************************************************
		ORG     0x000             	; processor reset vector

		goto    main             		 ; go to beginning of program
		

		ORG     0x004             	; interrupt vector location
		
		MOVWF 	w_temp		; 
		SWAPF 	STATUS, W
		CLRF 		STATUS
		MOVWF 	status_temp
		MOVF 		PCLATH, W
		MOVWF 	pclath_temp
		CLRF 		PCLATH
		

ServTMR
		btfss 	INTCON,TMR0IF	;        TMR0  
		goto 	EXIT				;   "" -         ServTMR 
		
		movlw 	.56
		movwf 	TMR0				;    56
		bcf 		INTCON,TMR0IF	;   							;      
		off_seg						; 
		
		btfss	PORTA,4
		goto	set_R3
		btfss	PORTA,7
		goto	set_R2
		btfss	PORTA,6
		goto	set_R1
		

set_R1	R1
		goto	CYCLE
set_R2	R2
		goto	CYCLE				
set_R3	R3
			
CYCLE       	movlw       ciph3        ;    W   ciph1.
            		addwf       index,W     ;    ciph6   ,
                                    			;       
                                    			;  Index, c     W.                                   

            	movwf     FSR         		;    W   FSR.
            	movf       INDF,W      	;     , 
                                   			;   FSR,   W.
            	movwf    seg_kod			;   PORTB 7- 
     		
		incf        index, F   	;   1   Index  
                                   		;    .
              movlw       .3         	;    W  3
              bcf         STATUS, Z   ;     Z.
              subwf       index, W     ;     Index  
                                    		; W      W.
              btfss       STATUS, Z   ;       ? 
              goto        EXIT       	;   =0 (  Index -    6), 
              clrf        	index                       ;       
              bsf		big_cykle                       ; 7-  (   
                                    ;  ,  ,   CYCLE).
                                    ;  =0 (  Index -   8),  
                                    ;  .
EXIT	MOVF 		pclath_temp, W	; 
		MOVWF 	PCLATH
		SWAPF 	status_temp, W
		MOVWF 	STATUS
		SWAPF 	w_temp, F
		SWAPF 	w_temp, W
	
		retfie                    			; return from interrupt

;
main
;**********************************************************************************************
;***************  MK
;**********************************************************************************************
		 BANK1
		 MOVLW    B'01111100'		;  
		 MOVWF    	OSCCON		;  8
		 MOVLW    B'10000101'		;  ,
		 MOVWF    	OPTION_REG	; 0 (1:64)
		 
		 ;****** ***********
		 
		 ;PORTA,0 -  - AN0, ,   
		 ;PORTA,1 -  - AN1, , 
		 ;PORTA,2 -  - AN2, ,  
		 ;PORTA,3 -  -  "-"
		 ;PORTA,4 -  -   1
		 ;PORTA,5 -  - 
		 ;PORTA,6 -  -   2
		 ;PORTA,7 -  -   3
		 
		 ;PORTB,0 - ,  "H"
		 ;PORTB,1 - ,  "G"
		 ;PORTB,2 - ,  "F"
		 ;PORTB,3 - ,  "E"
		 ;PORTB,4 - ,  "D"
		 ;PORTB,5 - ,  "C"
		 ;PORTB,6 - ,  "B"
		 ;PORTB,7 - ,  "A"
		 		 
		 CLRF 		PORTA 			; PORTA
		 CLRF 		PORTB 			; PORTB
		 
		 MOVLW	  B'00000111'	;AN0, AN1, AN2 
		 MOVWF	  ANSEL		;  
		 		  		 
		 MOVLW	 B'00101111'	; PORTA 
		 MOVWF	 TRISA			
		 MOVLW	 B'00000000'	; PORTB
		 MOVWF	 TRISB			
				
		 CLRF     	PIE2			; 	
		 CLRF     	PIE1
		 CLRF     	TXSTA
		 
		 MOVLW    B'11000000'   	;,     Vref =Vdd=5,12V
		 MOVWF    ADCON1
		 		 		 		
		 MOVLW    B'00000111'		; 
		 MOVWF    CMCON
		 
		 MOVLW    B'00000000'   	;  
		 MOVWF    	CVRCON				 
		 
		 
		 BANK2
		 CLRF     	WDTCON
		 BANK3
		 CLRF     	EECON1		;   
		 BANK0
		 CLRF     	PORTA			;     
		 CLRF     	PORTB			;  
		 CLRF     	PIR1
		 CLRF     	PIR2
		 
		 MOVLW    B'01000001'   	;Fosc/16, AN0/, Stop, ADC_ON
		 MOVWF    ADCON0
		 
		 CLRF     	CCP1CON		;  CCP
		 		
		 BANK1
		 clrf			SSPSTAT		; SSP
		 BANK0		
		 movlw		B'00000000'		; SSP
		 movwf		SSPCON
		
		 movlw		 b'10100000'
		 movwf 		INTCON		;     TMR0
		 movlw 		.56				;      TMR0   194
		 movwf 		TMR0
		 
		 
		 movlw 		.11				;Value to load into TMR1L
		 movwf 		TMR1H 		; Write High byte
		 clrf	 		TMR1L 			; Write High byte
		 
		 movlw		 b'00110001'	; 1
		 movwf 		T1CON
		 
		 clrf        	index			;  
		 clrf			count			
               ;clrf			count0
               ;clrf			count_I
               ;clrf			key_flag			
		 clrf			flags1
		 clrf			flags
		 clrf			count_tmr			
		 clrf			count_sec
		clrf			count_min			
		 clrf			count_hour
		clrf			mins_10		; 
        	clrf			hours_10	; 
		clrf			H_sum				; 
		clrf			L_sum				; 
		clrf			count_sampl
		off_seg		; 
		BSF      PORTA,7  
		BSF      PORTA,4
		BSF      PORTA,6 
		
		
		
		movlw       	b'00111000'		;u				
              movwf       	ciph1
		movlw       	b'01100001'		;1.		
              movwf       	ciph2
              movlw       	b'11111100'		;0				
              movwf       	ciph3
		R1							; 3 
		goto		 BEGIN
	
	
	;*****    HEX   
TABLE
       clrf    	PCLATH
       andlw   	H'0F'
	addwf   	PCL, f		;     .
	retlw   	b'11111100'           	; "0"
	retlw   	b'01100000'             	; "1"
	retlw   	b'11011010'            	; "2"
	retlw   	b'11110010'           	; "3"
	retlw   	b'01100110'            	; "4"
	retlw   	b'10110110'           	; "5"
	retlw   	b'10111110'        	; "6"
	retlw   	b'11100000'           	; "7"
	retlw   	b'11111110'           	; "8"
	retlw   	b'11110110'           	; "9"
              
             

;***********************  *********************
			
			
BEGIN	call		delay_3s			; 3 ,  
		bsf		mode			;   
		goto	V				;  

;*********** *******************************
START	
		;  
		clrf		count_btn			; 
		btfsc	knopka				; ?		
		goto	check_mode				;
		incfsz 	count_btn, f 			;,  
		goto	$-3					; 
		
		 
		clrf 		cnt1				;     			
	       clrf 		cnt2 
		movlw 	.10
		movwf 	cnt3
		
		;  
Btn1	btfsc	knopka          	;  ?		
		goto 	select			;,     	decfsz 	cnt1,f 
        	decfsz 	cnt1,f 			;   3 .
        	goto 	$-3 
        	decfsz 	cnt2,f 
        	goto 	$-5
        	decfsz 	cnt3,f 
        	goto 	$-7
        	call	 	Hour_Format				;   
		
		btfss	knopka          	;  ?		
		goto	$-1				;,  				
		goto	loop				; , 

		
;******************************************************		
		;  
select	btfsc	mode			;  
		goto 	$+3
		bsf		mode
		goto	V				;  

		bcf		mode
		goto	A				;  
		
;**************************************************************
check_mode	
		btfsc	mode			;  
		goto	switch			; 
		goto	A_convert
		
switch	btfss	ch_SA3			;  SA3
		goto	tt				; 0 -  
		btfss	SA3			; 
		goto 	V_en			; 
		goto	V_convert		;  	

tt		btfsc	SA3			; 
		goto	V_in			;   
		goto	V_convert		;  

;*************************************************************
		;    
V		btfss	SA3			;    	
		goto	V_en				;    

V_in	VOLT1					;    
		bsf		ch_SA3
		goto	init

V_en	VOLT2					;  
		bcf		ch_SA3

init		INIT_AD

V_convert
		
		call		AD_convert
		btfss	flags1,7			;  
		goto	loop				;
		call		Volt_Format
		bcf		flags1,7			; 
		goto	loop
;*************************************************************		
A		AMPER					; 
		INIT_AD				; AD   
		
A_convert
		call		AD_convert
		btfss	flags1,7			;  
		goto	loop				;
		call		Amper_Format	; ,   
		bcf		flags1,7			; 
		

;********** *****************************************
loop		btfss	big_cykle		;     	
		goto	$+3				;
		bcf		big_cykle		;
		goto	START	 		;   (Big cykle)
		
;********* *****************************************		
		
		btfss	PIR1, 0			;  1
		goto	loop	 			;  
		bcf		PIR1, 0
		movlw 	.11		 		; Value to load into TMR1H
		movwf	TMR1H
		clrf	 	TMR1L 			; Write High byte
		
		
		incf		count_tmr		;  	
		btfss	count_tmr,2		; 4 ?
		goto	loop				;		  
		
		clrf		count_tmr
		incf		count_sec		;  
		movfw	count_sec
		sublw 	.60
		btfss 	STATUS, Z 				; 60 seconds elapsed ?
		goto	loop	 					; no, done
		clrf 		count_sec 				; clear seconds
		incf 	count_min				 ; increment minutes
		
		movfw	 count_min
		sublw 	.10
		btfss 	STATUS, Z 				; 10  elapsed?
		goto	loop						; no, done
		clrf 		count_min				; clear minutes
		incf 	mins_10					;    
		
		movfw	 mins_10
		sublw 	.6
		btfss 	STATUS, Z 				; 6  ?
		goto	loop						; no, done
		clrf 		mins_10					; clear 10 minutes
		incf 	count_hour				; increment  hours
				
		movfw 	count_hour
		sublw 	.10
		btfss 	STATUS, Z 				; 10 hours elapsed?
		goto	loop						; no, done
		clrf 		count_hour				; clear hours
		incf		hours_10				;   
		
		movfw 	hours_10
		sublw 	.100
		btfss 	STATUS, Z 				; 100 hours elapsed?
		goto	loop	 					;,   
		clrf		hours_10
		goto 	loop
		
;**************************************************************
;********** AD  *************************
;**************************************************************
AD_convert		
		bsf		AD_start		; 
		nop
		btfsc	AD_start
		goto 	$-1
		
		movfw	ADRESH		;  
		movwf	H_byte
		BANK1
		movfw	ADRESL		;  
		BANK0
		movwf	L_byte
	
	; 16 
		movfw	H_byte		;  
		addwf	H_sum, f
		
		movfw	L_byte		;  
		addwf	L_sum, f
		
		btfsc	STATUS, C	;  
		incf		H_sum, f		;  
		
		incf		count_sampl, f	;  
		btfss	count_sampl, 4
		
		return
	
	;  32
		
		clrf		count_sampl
mm		incf		count_sampl, f
		bcf		STATUS, C			;   2
		rrf		H_sum
		rrf		L_sum
		
		movfw 	count_sampl
		sublw 	.5
		btfss 	STATUS, Z 				; 5  elapsed?
		goto	mm						; no, done
		
		movfw	H_sum
		movwf	H_byte
		
		movfw	L_sum
		movwf	L_byte
		bsf		flags1, 7			; 	
		clrf	H_sum				; 
		clrf	L_sum				; 
		clrf	count_sampl
		return		

;**************************************************************
;**********  *****************
;**************************************************************
Volt_Format
	       call    	b2_bcd   	;     
	                         			;   3-x . - 
	                         			; r1,r2
	        movf    tr1,w
	        call    	TABLE
	        movwf   ciph1
	        swapf   	tr2,w
	        call    	TABLE
	        movwf   ciph2
	        bsf     	ciph2,0 ;  
	        movf    	tr2,w
	        call    	TABLE
	        movwf   ciph3

		 movf    	tr1,w			; 0   
	        btfss   	STATUS,Z
	        goto    	$+3
	        movlw	b'00000000'
	        movwf	ciph1
	        return
;**************************************************************
;**********  ************************
;**************************************************************
Amper_Format
	        call    	b2_bcd   	;     
	                         			;   3-x . - 
	                         			; r1,r2
	        movf    tr1,w
	        call    	TABLE
	        movwf   ciph1
	        bsf     	 ciph1, 0 ;  
	        swapf   	 tr2,w
	        call    	TABLE
	        movwf   ciph2
	        movf    	tr2,w
	        call    	TABLE
	        movwf   ciph3
 
	        return
		
;**************************************************************
;**********   *****************
;**************************************************************
Hour_Format		
		movfw	mins_10			;  
		call    	TABLE				
		movwf   ciph3
				
		movfw 	count_hour		;  
		call    	TABLE
	       movwf   ciph2
	       bsf     	ciph2,0 			;  
	       
	       movfw 	hours_10		;  
	      	call    	TABLE
	       movwf   ciph1
	       return	

;**********************************************************************************************
;  bin to BCD 16bit->3 dec
;**********************************************************************************************
b2_bcd  
        	bcf     STATUS,C                ; clear the carry bit
		movlw   .16
		movwf   count
		clrf    tr1
		clrf    tr2
loop16  
        	rlf     L_byte,f
		rlf     H_byte,f
		rlf     tr2,f
		rlf     tr1,f
		
		decfsz  	count,f
		goto    	adjdec
		return

adjdec  
	       movlw   	tr2
		movwf   	FSR
		call    	adjbcd
	
		movlw   	tr1
		movwf   	FSR
		call    	adjbcd
	
		goto    	loop16
	
adjbcd  
	        movlw   3
		addwf   	0,W
		movwf   temp
		btfsc   	temp,3          ; test if result > 7
		movwf   0
		movlw   0x30
		addwf   	0,W
		movwf   	temp
		btfsc   	temp,7          ; test if result > 7
		movwf   0               	; save as msd
		return
;***************************************
;*****  10 ******************
delay_10
 			movlw   d'5'
 			movwf   fcounter
d_loop2
 			decfsz  fcounter,f
 			goto    d_loop2
 			return
;***************************************
;*****  3 ******************
delay_3s      movlw .12 
	             movwf cnt1 
	             clrf cnt2 
	             clrf cnt3 
dloop           decfsz cnt3,f 
	             goto $+2 
	             decfsz cnt2,f 
	             goto $+2 
	             decfsz cnt1,f 
	             goto dloop 
	             return


	END                       ; directive 'end of program'

